'''a = int(input())
b = int(input())
lunar_sum = max(a, b)
c = a+b
c = lunar_sum
lunar_product = min(a, b)
d = a*b
d = lunar_product
print(c, d)'''

from collections import deque, defaultdict


def bfs(start, max_distance, graph, n):
    visited = [False] * (n + 1)
    queue = deque([(start, 0)])  # (текущий склад, текущая дистанция)
    visited[start] = True
    protected_stores = set()

    while queue:
        current, distance = queue.popleft()
        protected_stores.add(current)

        if distance < max_distance:
            for neighbor in graph[current]:
                if not visited[neighbor]:
                    visited[neighbor] = True
                    queue.append((neighbor, distance + 1))

    return protected_stores


def main():
    n, m, k = map(int, input().split())

    # Построение графа
    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)

    protected_stores = set()

    # Обработка охранников
    for _ in range(k):
        p, h = map(int, input().split())
        protected_stores.update(bfs(p, h, graph, n))


    protected_stores = sorted(protected_stores)
    print(len(protected_stores))
    if protected_stores:
        print(" ".join(map(str, protected_stores)))
    else:
        print()


if __name__ == "__main__":
    main()