
from collections import deque, defaultdict


def bfs(start, max_distance, graph, n):
    visited = [False] * (n + 1)
    queue = deque([(start, 0)])
    visited[start] = True
    protected_stores = set()

    while queue:
        current, distance = queue.popleft()
        protected_stores.add(current)

        if distance < max_distance:
            for neighbor in graph[current]:
                if not visited[neighbor]:
                    visited[neighbor] = True
                    queue.append((neighbor, distance + 1))

    return protected_stores


def main():
    n, m, k = map(int, input().split())


    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)

    protected_stores = set()


    for _ in range(k):
        p, h = map(int, input().split())
        protected_stores.update(bfs(p, h, graph, n))


    protected_stores = sorted(protected_stores)
    print(len(protected_stores))
    if protected_stores:
        print(" ".join(map(str, protected_stores)))
    else:
        print()


if __name__ == "__main__":
    main()


'''def calculate_distance(p1, p2):
    return abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])


def tsp_dp(points):
    n = len(points)

    dist = [[0] * n for _ in range(n)]
    for i in range(n):
        for j in range(n):
            dist[i][j] = calculate_distance(points[i], points[j])

 
    dp = [[float('inf')] * n for _ in range(1 << n)]
    dp[1][0] = 0 


    for mask in range(1 << n):
        for u in range(n):
            if mask & (1 << u):  
                for v in range(n):
                    if not (mask & (1 << v)): 
                        new_mask = mask | (1 << v)
                        dp[new_mask][v] = min(dp[new_mask][v], dp[mask][u] + dist[u][v])


    min_path = float('inf')
    final_mask = (1 << n) - 1
    for u in range(1, n):
        min_path = min(min_path, dp[final_mask][u] + dist[u][0])

    return min_path


def main():
    n = int(input())
    points = [tuple(map(int, input().split())) for _ in range(n)]

    result = tsp_dp(points)
    print(f"{result:.6f}")


if __name__ == "__main__":
    main()'''