'''a = int(input())
b = int(input())
lunar_sum = max(a, b)
c = a+b
c = lunar_sum
lunar_product = min(a, b)
d = a*b
d = lunar_product
print(c, d)'''

import sys
import itertools


def calculate_distance(p1, p2):
    return abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])


def tsp_dp(points):
    n = len(points)
    # Создаем матрицу расстояний
    dist = [[0] * n for _ in range(n)]
    for i in range(n):
        for j in range(n):
            dist[i][j] = calculate_distance(points[i], points[j])

    # Инициализация DP массива
    dp = [[float('inf')] * n for _ in range(1 << n)]
    dp[1][0] = 0  # Начинаем с первого пункта (индекс 0)

    # Заполнение DP массива
    for mask in range(1 << n):
        for u in range(n):
            if mask & (1 << u):  # Если u в маске
                for v in range(n):
                    if not (mask & (1 << v)):  # Если v не в маске
                        new_mask = mask | (1 << v)
                        dp[new_mask][v] = min(dp[new_mask][v], dp[mask][u] + dist[u][v])

    # Получаем минимальный путь, возвращаясь в начальную точку
    min_path = float('inf')
    final_mask = (1 << n) - 1
    for u in range(1, n):
        min_path = min(min_path, dp[final_mask][u] + dist[u][0])

    return min_path


def main():
    n = int(input())
    points = [tuple(map(int, input().split())) for _ in range(n)]

    result = tsp_dp(points)
    print(f"{result:.6f}")


if __name__ == "__main__":
    main()